/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   lem_in.c                                           :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: mndhlovu <marvin@42.fr>                    +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2019/03/25 06:31:05 by mndhlovu          #+#    #+#             */
/*   Updated: 2019/04/10 15:35:18 by tmaze            ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "lem_in.h"

static t_node	*get_node_role(t_lmdata *data, char role)
{
	t_node	*it;

	it = data->nodes_data;
	while (it)
	{
		if (it->role == role)
			return (it);
		it = it->next;
	}
	return (NULL);
}

static int		lem_in(t_syntax *synt, t_holder *holder,
					t_lmdata *lmdata)
{
	if (!(lm_parser(synt, lmdata, holder)))
		return (0);
	if (!lst_indinit(lmdata))
		return (0);
	if (!(lm_adj_parser(lmdata, holder)))
		return (0);
	return (1);
}

int				lm_error_exit(void)
{
	ft_putendl_fd("ERROR", 2);
	return (1);
}

int				main(int ac, char **av)
{
	t_syntax	synt;
	t_lmdata	ldata;
	t_holder	holder;
	t_ind		**ret;
	int			i;

	(void)av;
	i = 0;
	if (ac == 1)
	{
		lm_init_data(&synt, &holder, &ldata);
		if (!(lem_in(&synt, &holder, &ldata)))
			return (lm_error_exit());
		if ((ret = edmunds_karp(&ldata, get_node_role(&ldata, 's')->ind
								, get_node_role(&ldata, 'e')->ind)) == NULL)
			return (lm_error_exit());
		i = 0;
		while (ret[i])
			i++;
		push_ants(&ldata, ret, i);
		tablst_inddel(ret);
		i = 0;
		while (i < ldata.nb_nodes)
		{
			lst_inddel(&(ldata.adj[i]));
			i++;
		}
		ft_memdel((void**)&(ldata.adj));
		return (0);
	}
	return (1);
}
